'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ibeam = require('ibeam');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var App = function () {
  function App() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, App);

    var clientOpts = {
      host: options.host,
      format: 'json'
    };
    if (options.hasOwnProperty('https')) {
      clientOpts.https = options.https;
    }
    if (options.hasOwnProperty('httpController')) {
      clientOpts.httpController = options.httpController;
    }
    this._ApplicationId = options.applicationId;
    this._JavaScriptKey = options.javaScriptKey;
    this._MasterKey = options.masterKey;
    this._bareClient = new _ibeam.Client(clientOpts);
    this.client = (0, _ibeam.addResponsePostProcessor)((0, _ibeam.addRequestPreProcessor)(this._bareClient, this.requestPreProcessor.bind(this)), this.responsePostProcessor);
  }

  _createClass(App, [{
    key: 'requestPreProcessor',
    value: function requestPreProcessor(method, path, payload, options) {
      var json = {
        _ApplicationId: this._ApplicationId
      };
      if (this._JavaScriptKey) {
        json._JavaScriptKey = this._JavaScriptKey;
      }
      if (payload && (typeof payload === 'undefined' ? 'undefined' : _typeof(payload)) === 'object') {
        for (var key in payload) {
          json[key] = payload[key];
        }
      }
      if (options.useMasterKey) {
        if (this._MasterKey) {
          json._MasterKey = this._MasterKey;
        } else {
          throw new Error('Cannot use the master key. It has not been provided.');
        }
      }
      if (options.sessionToken) {
        json._SessionToken = options.sessionToken;
      }
      json._method = method;
      var clientOpts = {
        headers: {
          'Content-Type': 'text/plain'
        }
      };
      for (var _key in options) {
        if (_key !== 'sessionToken' && _key !== 'useMasterKey') {
          clientOpts[_key] = options[_key];
        }
      }

      return {
        method: 'POST',
        payload: json,
        options: clientOpts
      };
    }
  }, {
    key: 'responsePostProcessor',
    value: function responsePostProcessor(response) {
      var body = null;
      try {
        body = JSON.parse(response.response);
      } catch (e) {
        return Promise.reject({
          status: response.status,
          response: 'Could not parse JSON response: "' + response.response + '"'
        });
      }
      if (response.status >= 200 && response.status < 300) {
        return Promise.resolve({
          status: response.status,
          response: body
        });
      }
      return Promise.reject({
        status: response.status,
        response: body
      });
    }
  }]);

  return App;
}();

exports.default = App;