'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Cloud;

var _WireFormat = require('./WireFormat');

function Cloud(app, name) {
  var data = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];
  var options = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];

  if (typeof name !== 'string' || name.length === 0) {
    throw new TypeError('Cloud function name must be a string.');
  }

  var payload = (0, _WireFormat.encode)(data);

  return app.client.post('functions/' + name, payload, options).then(function (_ref) {
    var response = _ref.response;

    var decoded = (0, _WireFormat.decode)(response);
    if (decoded && decoded.hasOwnProperty('result')) {
      return Promise.resolve(decoded.result);
    }
    return Promise.reject('The server returned an invalid response.');
  }).catch(function (_ref2) {
    var response = _ref2.response;

    return Promise.reject(response);
  });
}