'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = Save;

var _WireFormat = require('./WireFormat');

var _deepCopy = require('./deepCopy');

var _deepCopy2 = _interopRequireDefault(_deepCopy);

var _Ops = require('./Ops');

var Ops = _interopRequireWildcard(_Ops);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Save(app, className, object) {
  var options = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];

  if (!object || (typeof object === 'undefined' ? 'undefined' : _typeof(object)) !== 'object') {
    return Promise.reject(new Error('Cannot save an invalid object'));
  }
  if (!object._opSet) {
    object = Ops.set(object, {});
  }
  var method = object.objectId ? 'PUT' : 'POST';
  if (object.objectId && typeof object.objectId !== 'string') {
    throw new Error('Invalid id: objectId field must be a string');
  }
  var path = object.objectId ? 'classes/' + className + '/' + object.objectId : 'classes/' + className;
  return app.client.raw(method, path, (0, _WireFormat.encode)(object._opSet), options).then(function (response) {
    var result = response.response;
    var savedServerData = {};
    var setFields = {};
    for (var key in object._opSet) {
      if (!object._opSet[key] || !object._opSet[key].__op) {
        setFields[key] = object._opSet[key];
      }
    }
    if (object.objectId) {
      setFields.objectId = object.objectId;
    }
    Object.assign(savedServerData, (0, _deepCopy2.default)(object._serverData || {}), setFields, (0, _WireFormat.decode)(result));
    var savedObject = {};
    Object.assign(savedObject, (0, _deepCopy2.default)(object._serverData || {}), setFields, (0, _WireFormat.decode)(result));
    Object.defineProperty(savedObject, '_serverData', {
      enumerable: false,
      writable: false,
      configurable: false,
      value: savedServerData
    });
    Object.defineProperty(savedObject, '_className', {
      enumerable: false,
      writable: false,
      configurable: false,
      value: className
    });
    Object.defineProperty(savedObject, '_opSet', {
      enumerable: false,
      writable: false,
      configurable: false,
      value: {}
    });
    return savedObject;
  });
}