'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = deepCopy;

var _Date = require('./Date');

function deepCopy(obj) {
  var seen = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];

  if (!obj || (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) !== 'object') {
    return obj;
  }
  if ((0, _Date.isDate)(obj)) {
    return new Date(obj.getTime());
  }
  if (seen.indexOf(obj) > -1) {
    throw new Error('Cannot copy circular object references');
  }
  var newSeen = seen.concat([obj]);
  if (Array.isArray(obj)) {
    return obj.map(function (el) {
      return deepCopy(el, newSeen);
    });
  }
  var copy = {};
  for (var k in obj) {
    copy[k] = deepCopy(obj[k], newSeen);
  }
  return copy;
}